package com.perfectech.tis.syncClasses;

import android.content.Context;
import android.util.Log;

import com.perfectech.tis.DateConvertClass;
import com.perfectech.tis.TISDBHelper;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;

import com.perfectech.tis.webServices.SyncJson;

/**
 * Created by jnissley on 7/23/15.
 */
public class SyncDVIR {
    private static final String sDBName = "TIS.db";
    //public static Activity inActivity;
    public static Context oContext;
    public static String sDVIRNum;
    private static final int iVersionVal = 6;

    public static Boolean updNewDVIR() throws Exception {
        // get DVIR information into the database
        Boolean bRtnValue = false;
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();

        try {
            String sDVIRSQL = "select DriverNo, TruckNo, TrailerNo, Location, BeginMileage, " +
                    "Remarks, DVIRDateTime from DVIREntered " +
                    "where DVIRNo = '" + sDVIRNum + "'";
            ArrayList<ArrayList<String>> sDVIRList = oDB.selectRecordsFromDBList(
                    sDVIRSQL, null);

            String sDVIRItemsSQL = "select DVIRFields.Title, DVIRFieldValues.value " +
                    "from DVIRFieldValues, DVIRFields where DVIRFields._id = DVIRFieldValues.FieldId " +
                    "and DVIRFieldValues.DVIRNo = '" + sDVIRNum + "'";
            ArrayList<ArrayList<String>> sDVIRItemsList = oDB.selectRecordsFromDBList(
                    sDVIRItemsSQL, null);

            oDB.close();

            JSONObject DVIRObject = new JSONObject();
            //There is only one DVIR so just get the one
            if (sDVIRList != null) {
                ArrayList<String> tempList = sDVIRList.get(0);
                try {
                    DVIRObject.put("DVIRNo", sDVIRNum);
                    DVIRObject.put("DriverNo", tempList.get(0));
                    DVIRObject.put("TruckNo", tempList.get(1));
                    DVIRObject.put("TrailerNo", tempList.get(2));
                    DVIRObject.put("Location", tempList.get(3));
                    DVIRObject.put("BeginMileage", tempList.get(4));
                    DVIRObject.put("Remarks", tempList.get(5));
                    DVIRObject.put("DVIRDateTime", tempList.get(6));
                } catch (Exception ex) {
                    //To Do
                }
            }
            // Put the DVIR items into a JSON array
            JSONArray DVIRItemsArray = new JSONArray();
            if (sDVIRItemsList != null) {
                for (int i = 0; i < sDVIRItemsList.size(); i++) {
                    JSONObject DVIRItemsObject = new JSONObject();
                    ArrayList<String> tempList = sDVIRItemsList.get(i);
                    try {
                        //DVIRItemsObject.put("DVIRNo", sDVIRNum); We already know this
                        DVIRItemsObject.put("DVIRField", tempList.get(0));
                        DVIRItemsObject.put("DVIRFieldValue", tempList.get(1));
                        DVIRItemsArray.put(DVIRItemsObject);
                    } catch (Exception ex) {
                        //To Do
                    }
                }
            }
            JSONObject DVIRInfoObject = new JSONObject();
            DVIRInfoObject.put("DVIR", DVIRObject);
            DVIRInfoObject.put("DVIRItems", DVIRItemsArray);
            SyncJson oSyncDVIRItems = new SyncJson();
            oSyncDVIRItems.oContext = oContext;
            oSyncDVIRItems.sendString = DVIRInfoObject.toString();
            oSyncDVIRItems.webserviceName = "insDVIRWS.php";
            String sResponse = oSyncDVIRItems.SyncData();
            if (sResponse.toUpperCase().equals("SUCCESS")) {
                bRtnValue = true;
            } else {
                bRtnValue = false;
            }
            String stest = sResponse;
        } catch (Throwable t) {
            Log.d("updNewDVIR:", t.toString());
            t.printStackTrace();
            bRtnValue = false;
        } finally {
            oDB.close();
        }
        return bRtnValue;
    }

    public static Boolean updCompletedDVIR() throws Exception {
        // get DVIR information into the database
        Boolean bRtnValue = false;
        TISDBHelper oDB = new TISDBHelper(oContext, sDBName, null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();

        try {
            String sDVIRSQL = "select EndMileage, OutOfStateMileage " +
                    "from DVIREntered " +
                    "where DVIRNo = '" + sDVIRNum + "'";
            ArrayList<ArrayList<String>> sDVIRList = oDB.selectRecordsFromDBList(
                    sDVIRSQL, null);

            oDB.close();

            DateConvertClass oDateConvertClass = new DateConvertClass();
            oDateConvertClass.oContext = oContext;
            String sCurrentDateTime = oDateConvertClass.GMTTimestamp();
            JSONObject DVIRObject = new JSONObject();
            //There is only one DVIR so just get the one
            if (sDVIRList != null) {
                ArrayList<String> tempList = sDVIRList.get(0);
                try {
                    DVIRObject.put("DVIRNo", sDVIRNum);
                    DVIRObject.put("EndMileage", tempList.get(0));
                    DVIRObject.put("OutOfStateMileage", tempList.get(1));
                    DVIRObject.put("CompleatedDateTime", sCurrentDateTime);
                } catch (Exception ex) {
                    //To Do
                }
            }
            SyncJson oSyncDVIRItems = new SyncJson();
            oSyncDVIRItems.oContext = oContext;
            oSyncDVIRItems.sendString = DVIRObject.toString();
            oSyncDVIRItems.webserviceName = "updDVIRWS.php";
            String sResponse = oSyncDVIRItems.SyncData();
            String stest = sResponse;
        } catch (Throwable t) {
            Log.d("updCompleteDVIR:", t.toString());
            t.printStackTrace();
            bRtnValue = false;
        } finally {
            oDB.close();
        }
        return bRtnValue;
    }
}
